# Class VulkanRectangle2D.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanRectangle2D.Builder

Enclosing class:
  `VulkanRectangle2D`

public static final class VulkanRectangle2D.Builder extends Object
Builds instances of type `VulkanRectangle2D`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanRectangle2D`
  `build()`
  Builds a new `VulkanRectangle2D`.
  `final VulkanRectangle2D.Builder`
  `from(VulkanRectangle2DType instance)`
  Fill a builder with attribute values from the provided `VulkanRectangle2DType` instance.
  `final VulkanRectangle2D.Builder`
  `setExtent(VulkanExtent2D extent)`
  Initializes the value for the `extent` attribute.
  `final VulkanRectangle2D.Builder`
  `setOffset(VulkanOffset2D offset)`
  Initializes the value for the `offset` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanRectangle2D.Builder from(VulkanRectangle2DType instance)
    Fill a builder with attribute values from the provided `VulkanRectangle2DType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setOffset

    public final VulkanRectangle2D.Builder setOffset(VulkanOffset2D offset)
    Initializes the value for the `offset` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `offset`.

    Parameters:
      `offset` - The value for offset
    Returns:
      `this` builder for use in a chained invocation

  - ### setExtent

    public final VulkanRectangle2D.Builder setExtent(VulkanExtent2D extent)
    Initializes the value for the `extent` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `extent`.

    Parameters:
      `extent` - The value for extent
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanRectangle2D build()
    Builds a new `VulkanRectangle2D`.
    Returns:
      An immutable instance of VulkanRectangle2D
    Throws:
      `IllegalStateException` - if any required attributes are missing